commit 17259ddb3ecd74a6736c7b6bae62d3f942d6008d
Author: freddy77 <freddy77>
Date:   Sun Nov 29 19:02:45 2009 +0000

    Test univarchar from server

diff --git a/ChangeLog b/ChangeLog
index 1b19737..e6395a0 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Sun Nov 29 20:02:37 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/odbc/unittests/data.c: Test univarchar from server
+
 Sun Nov 29 19:56:38 CET 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/odbc.c: Fix row number return for cursors
 
@@ -1929,4 +1932,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2892 2009/11/29 18:56:47 freddy77 Exp $
+$Id: ChangeLog,v 1.2893 2009/11/29 19:02:45 freddy77 Exp $
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index d811938..de96279 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -13,12 +13,14 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: data.c,v 1.30 2009/08/20 18:59:29 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.31 2009/11/29 19:02:45 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
 static char sbuf[1024];
 
+static int ignore_select_error = 0;
+
 static void
 Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, const char *expected)
 {
@@ -37,7 +39,17 @@ Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, con
 		sprintf(sbuf, "SELECT CONVERT(%s, %s) COLLATE Latin1_General_CI_AS AS data", type, value_to_convert);
 	else if (strcmp(type, "SQL_VARIANT") == 0)
 		sprintf(sbuf, "SELECT CONVERT(SQL_VARIANT, %s) AS data", value_to_convert);
-	Command(sbuf);
+	else if (strncmp(value_to_convert, "u&'", 3) == 0)
+		sprintf(sbuf, "SELECT CONVERT(%s, %s) AS data", type, value_to_convert);
+	if (ignore_select_error) {
+		if (Command2(sbuf, "SENo") == SQL_ERROR) {
+			ResetStatement();
+			return;
+		}
+	} else {
+		Command(sbuf);
+	}
+	ignore_select_error = 0;
 	SQLBindCol(Statement, 1, out_c_type, out_buf, sizeof(out_buf), &out_len);
 	CHKFetch("S");
 	CHKFetch("No");
@@ -153,6 +165,9 @@ main(int argc, char *argv[])
 		Test("NVARCHAR(20)", "-24785  ", SQL_C_LONG, "-24785");
 	}
 
+	ignore_select_error = 1;
+	Test("UNIVARCHAR(10)", "u&'\\06A4\\FBA5'", SQL_C_WCHAR, "2 \\u06a4\\ufba5");
+
 	/* case (1) */
 	Test("DECIMAL", "1234.5678", SQL_C_BINARY, "120001D3040000000000000000000000000000");
 	Test("NUMERIC", "8765.4321", SQL_C_BINARY, "1200013D220000000000000000000000000000");

